diff --git a/src/base/init/config.c b/src/base/init/config.c
index 872199cde..eae5688ea 100644
--- a/src/base/init/config.c
+++ b/src/base/init/config.c
@@ -1336,6 +1336,8 @@ config_init(int argc, char **argv)
 	    }
 	    if (optarg) {
 		char *opt_e;
+		if (strchr(optarg, 'c'))
+		    config.clip_term = 1;
 		if (strchr(optarg, 'd'))
 		    config.dumb_video = 1;
 		if ((opt_e = strchr(optarg, 'e'))) {
diff --git a/src/include/emu.h b/src/include/emu.h
index 27af60536..f0e5b9acf 100644
--- a/src/include/emu.h
+++ b/src/include/emu.h
@@ -165,6 +165,7 @@ typedef struct config_info {
        char *term_size;
        int dumb_video;
        int tty_stderr;
+       int clip_term;
        int vga;
        boolean X;
        boolean X_fullscreen;
diff --git a/src/plugin/term/Makefile b/src/plugin/term/Makefile
index e7a8f4b09..99585f4dc 100644
--- a/src/plugin/term/Makefile
+++ b/src/plugin/term/Makefile
@@ -9,7 +9,7 @@ include ../plugins.mak
 
 ALL_CFLAGS+=$(DL_CFLAGS) -DENABLE_SLFUTURE_CONST
 ALL_CPPFLAGS+=$(SLANGINC)
-CFILES=term_core.c terminal.c keyb_slang.c mouse_xterm.c
+CFILES=term_core.c terminal.c keyb_slang.c mouse_xterm.c clip_term.c
 
 ifeq ($(USE_DL_PLUGINS),1)
 all: $(BINPATH)/bin/libplugin_term.so
diff --git a/src/plugin/term/Makefile.conf.in b/src/plugin/term/Makefile.conf.in
index b5b8a8132..b0381f411 100644
--- a/src/plugin/term/Makefile.conf.in
+++ b/src/plugin/term/Makefile.conf.in
@@ -8,4 +8,4 @@
 # This file is included by all Makefiles
 
 SLANGINC:=@SLANG_CFLAGS@
-SLANGLIB:=@SLANG_LIBS@
+SLANGLIB:=@SLANG_LIBS@ @LIBS@
diff --git a/src/plugin/term/clip_term.c b/src/plugin/term/clip_term.c
new file mode 100644
index 000000000..cbe72b58a
--- /dev/null
+++ b/src/plugin/term/clip_term.c
@@ -0,0 +1,87 @@
+/*
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+/*
+ * Purpose: terminal clipboard support (OSC-52)
+ *
+ * Note: only copy support for now (no paste)
+ *
+ * Author: @stsp
+ */
+
+#include <stdio.h>
+#include <alloca.h>
+#include <b64/cencode.h>
+#include "init.h"
+#include "types.h"
+#include "emu.h"
+#include "clipboard.h"
+
+static int cterm_clear(void)
+{
+  fprintf(stdout, "\033]52;c;-\a");
+  fflush(stdout);
+  return TRUE;
+}
+
+static int base64_encoded_size(int size)
+{
+  return (size + 2) / 3 * 4 + 1;
+}
+
+static int cterm_write(int type, const char *p, int size)
+{
+  int cnt;
+  base64_encodestate state;
+  char *buf = alloca(base64_encoded_size(size));
+
+  fprintf(stdout, "\033]52;c;");
+  base64_init_encodestate(&state);
+  cnt = base64_encode_block(p, size, buf, &state);
+  if (cnt > 0)
+    fwrite(buf, 1, cnt, stdout);
+  cnt = base64_encode_blockend(buf, &state);
+  if (cnt > 0)
+    fwrite(buf, 1, cnt, stdout);
+  fprintf(stdout, "\a");
+  fflush(stdout);
+  return TRUE;
+}
+
+static int cterm_getsize(int type)
+{
+  return 0;
+}
+
+static int cterm_getdata(int type, char *p, int size)
+{
+  return FALSE;
+}
+
+static struct clipboard_system clip_term =
+{
+  cterm_clear,
+  cterm_write,
+  cterm_getsize,
+  cterm_getdata,
+  "terminal clipboard",
+};
+
+CONSTRUCTOR(static void clipterm_initialize(void))
+{
+  if (config.clip_term)
+    register_clipboard_system(&clip_term);
+}
diff --git a/src/plugin/term/configure.ac b/src/plugin/term/configure.ac
index 46e653232..dcfd14014 100644
--- a/src/plugin/term/configure.ac
+++ b/src/plugin/term/configure.ac
@@ -3,4 +3,8 @@ AC_INIT
 AC_CONFIG_FILES([Makefile.conf])
 PKG_CHECK_MODULES([SLANG], [slang],,
     AC_MSG_ERROR([slang development headers not found]))
+AC_CHECK_LIB(b64, base64_encode_block,,
+    AC_MSG_ERROR([b64 libs not found]))
+AC_CHECK_HEADER([b64/cencode.h],,
+    AC_MSG_ERROR([b64 development headers not found]))
 AC_OUTPUT
